[Posted December 8, 2019](https://forum.armbian.com/topic/12162-single-armbian-image-for-rk-aml-aw-aarch64-armv8/?tab=comments#comment-90679)  
I noticed that the Build_Armbian git tree had a new set of changes merged in a couple of days ago.  I tried it out last night and there is one issue that I have seen so far.  I did a build of 'Armbian_19.11.3_Aml-g12_bionic_current_5.4.0.img and the debs and img are missing the dtb files.  I will copy the dtb's from another build to further test, but wanted to let you know of this issue.  I noticed a lot of code restructuring in this set of build changes, and since it hasn't been announced yet, I suspect I am trying things before they are ready.

[Posted April 4](https://forum.armbian.com/topic/13611-infrastructure-needed-for-releasing-new-kernels-for-armbian-for-tv-boxes/)  
I am starting a new thread as this discussion doesn't belong in the "Single Armbian image for RK + AML + AW" thread.

The end user need is that users (I think this is especially true of TV box users) think of Armbian for TV boxes like a standard linux distribution.  What this means is that they expect to receive security updates and critical bug fixes.  They are after all trying to run home servers and desktops on this platform.  And for the most part they get these fixes from the upstream distributions (ubuntu or debian).  However they don't get fixes for the linux kernel.  The question "how do I get kernel updates?" gets asked quite frequently in the TV box sub-forum (and if users aren't asking that question they probably assume they are getting updates through apt and don't realize they are not, or don't care at all about security).

@balbes150 has been working on building linux-image .deb files for the TV box builds, and I think with today's patches he has that working (i've looked at the code, but haven't tested that yet).  He has also been experimenting with deploying these kernel images via apt.armbian.com.  As was just discussed in IRC @igor correctly points out that the Armbian TV box work is a fork of Armbian and not supported.  But if we are using armbian infrastructure to deploy TV box kernel builds that line is certainly blurred.
...

[Posted April 14](https://forum.armbian.com/topic/13611-infrastructure-needed-for-releasing-new-kernels-for-armbian-for-tv-boxes/?tab=comments#comment-99474)  
What you describe can theoretically be accomplished today through the use of device tree include files (.dtsi).  And if you look at the source code, you will see that this mechanism is already used extensively to overlay board specific items on top of base CPU specifications.  Adding an additional layer on top doesn't provide additional functionality that couldn't be accomplished today.

 

Howerver, the scope of the problem is much bigger in the armbian world than in the Android and Raspbian world.  In both Android and Raspbian the base hardware is more constrained (i.e. the models of Raspberry Pi are a relatively small number with a small set of well known cpus, etc).  In the TV box world of armbian, you have three different primary CPU manufacturers (Amlogic, Rockchip, Allwinner) each with a wide variety of different cpu architectures.  Then you have many, many manufacturers that are putting together boards with all manner of third party chips for memory, nand, wifi, ethernet, bluetooth (and for most of them there is no source code available).  And since the goal of these manufacturers is to produce the cheapest tv box possible, they are likely using components that are inexpensive and thus not well supported.  Combine those hundreds of different devices with the fact that there is no upstream support from the board manufacturers and component makers to support their products (not even providing source code for others to do it) and you have a massive undertaking.  Then consider that there are only a handful of developers within armbian capable of working at this level of the code and you have a problem that isn't solvable today.

